﻿using ConfectioneryDatabaseImplement.Models;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConfectioneryDatabaseImplement
{
    public class ConfectioneryDatabase : DbContext
    {
        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (optionsBuilder.IsConfigured == false)
            {
                optionsBuilder.UseNpgsql(@"
                    Host=localhost;
                    Port=5432;
                    Database=ConfectioneryDatabaseLab5;
                    Username=postgres;
                    Password=postgres");
            }
            base.OnConfiguring(optionsBuilder);
        }
        public virtual DbSet<Client> Clients { set; get; }
        public virtual DbSet<Component> Components { set; get; }
        public virtual DbSet<Pastry> Pastries { set; get; }
        public virtual DbSet<PastryComponent> PastryComponents { set; get; }
        public virtual DbSet<Implementer> Implementers { set; get; }
        public virtual DbSet<Order> Orders { set; get; }
    }
}
